%ifarch ppc64le loongarch64
%global run_valgrind_tests OFF
%else
%global run_valgrind_tests ON
%endif

Summary: YANG data modeling language library
Name:    libyang
Version: 2.1.148
Release: 1%{?dist}
License: BSD
Url:     https://github.com/CESNET/libyang
Source0: %{url}/archive/v%{version}.tar.gz

BuildRequires: cmake doxygen gcc cmake(cmocka) make pkgconfig(libpcre2-8) valgrind

%package devel
Summary:    Development files for libyang
Requires:   %{name} = %{version}-%{release} pcre2-devel

%package tools
Summary:    YANG validator tools
Requires:   %{name} = %{version}-%{release}

%description devel
Headers of libyang library.

%description tools
YANG validator tools.

%description
Libyang is YANG data modeling language parser and toolkit written (and providing API) in C.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%cmake \
   -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \
   -DCMAKE_BUILD_TYPE=RELWITHDEBINFO \
   -DENABLE_LYD_PRIV=ON \
   -DENABLE_VALGRIND_TESTS=%{run_valgrind_tests}
%cmake_build

%check
pushd %{_target_cpu}-%{_vendor}-linux-gnu
%ifarch loongarch64
ctest --output-on-failure -E "yanglint_in_list|yanglint_in_feature|yanglint_in_completion" -V %{?_smp_mflags}
%else
ctest --output-on-failure -V %{?_smp_mflags}
%endif
popd


%install
%cmake_install

%files
%license LICENSE
%{_libdir}/libyang.so.2
%{_libdir}/libyang.so.2.*
%{_datadir}/yang/modules/libyang/*.yang
%dir %{_datadir}/yang/
%dir %{_datadir}/yang/modules/
%dir %{_datadir}/yang/modules/libyang/

%files tools
%{_bindir}/yanglint
%{_bindir}/yangre
%{_datadir}/man/man1/yanglint.1.gz
%{_datadir}/man/man1/yangre.1.gz

%files devel
%{_libdir}/libyang.so
%{_libdir}/pkgconfig/libyang.pc
%{_includedir}/libyang/*.h
%dir %{_includedir}/libyang/

%changelog
* Tue Feb 18 2025 xiaoyunzhao <xiaoyunzhao@opencloudos.tech> - 2.1.148-1
- [Type] need_sync
- [DESC] upgrade to 2.1.148: fix CVE-2024-55553 requires upgrading frr, 
         frr-10.2.1 requires libyang version higher than 2.1.128.

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.4-8
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.4-7
- Rebuilt for loongarch release

* Mon Jul 15 2024 Pengda Dou <doupengda@loongson> - 2.1.4-6
- [Type] other
- [DESC] fix build error for loongarch64

* Thu Mar 14 2024 Chunsheng Luo <luffyluo@tencent.com> - 2.1.4-5
- Fix CVE-2023-26916 CVE-2023-26917

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.4-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.4-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 9 2023 Shuo Wang <abushwang@tencent.com> - 2.1.4-1
- initial build
